export declare type State = object;
export declare type PartialState<T extends State> = Partial<T> | ((state: T) => Partial<T>);
export declare type StateSelector<T extends State, U> = (state: T) => U;
export declare type EqualityChecker<T> = (state: T, newState: T) => boolean;
export declare type StateListener<T> = (state: T, previousState: T) => void;
/**
 * @deprecated Use `StateListener<T>` instead of `StateSliceListener<T>`.
 */
export declare type StateSliceListener<T> = (slice: T, previousSlice: T) => void;
export declare type Subscribe<T extends State> = {
    (listener: StateListener<T>): () => void;
};
export declare type SetState<T extends State> = {
    _(partial: T | Partial<T> | ((state: T) => T | Partial<T>), replace?: boolean | undefined): void;
}['_'];
export declare type GetState<T extends State> = () => T;
export declare type Destroy = () => void;
export declare type StoreApi<T extends State> = {
    setState: SetState<T>;
    getState: GetState<T>;
    subscribe: Subscribe<T>;
    destroy: Destroy;
};
export declare type StateCreator<T extends State, Mis extends [StoreMutatorIdentifier, unknown][] = [], Mos extends [StoreMutatorIdentifier, unknown][] = [], U = T> = ((setState: Get<Mutate<StoreApi<T>, Mis>, 'setState', undefined>, getState: Get<Mutate<StoreApi<T>, Mis>, 'getState', undefined>, store: Mutate<StoreApi<T>, Mis>, $$storeMutations: Mis) => U) & {
    $$storeMutators?: Mos;
};
export interface StoreMutators<S, A> {
}
export declare type StoreMutatorIdentifier = keyof StoreMutators<unknown, unknown>;
export declare type Mutate<S, Ms> = Ms extends [] ? S : Ms extends [[infer Mi, infer Ma], ...infer Mrs] ? Mutate<StoreMutators<S, Ma>[Mi & StoreMutatorIdentifier], Mrs> : never;
declare type Get<T, K, F = never> = K extends keyof T ? T[K] : F;
declare type CreateStore = {
    <T extends State, Mos extends [StoreMutatorIdentifier, unknown][] = []>(initializer: StateCreator<T, [], Mos>): Mutate<StoreApi<T>, Mos>;
    <T extends State>(): <Mos extends [StoreMutatorIdentifier, unknown][] = []>(initializer: StateCreator<T, [], Mos>) => Mutate<StoreApi<T>, Mos>;
};
declare const createStore: CreateStore;
export default createStore;
